package com.jxdinfo.hussar.core.qr;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import com.jxdinfo.hussar.core.bouncycastle.jce.provider.asymmetric.ec.EC5Util;
import com.jxdinfo.hussar.core.qr.MatrixToImageWriter;
import com.jxdinfo.hussar.core.qr.QrImage;
import com.jxdinfo.hussar.core.support.ClassKit;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.HashMap;
import javax.imageio.ImageIO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ImgQrTool {

   private static MultiFormatWriter F = new MultiFormatWriter();
   private static final int j = 2;
   private static final int G = 80;
   private static Logger C = LoggerFactory.getLogger(ImgQrTool.class);
   private static final int e = 80;
   private static final int import = 40;


   public static void encode(String a, int a1, int a2, String a3, OutputStream a4) {
      try {
         ImageIO.write(native(a, a1, a2, a3), ClassKit.throw("\u0006;\b"), a4);
      } catch (IOException var5) {
         var5.printStackTrace();
      } catch (WriterException var6) {
         var6.printStackTrace();
      }
   }

   public static void createSimpleQr(String a, int a1, int a2, String a3) {
      FileOutputStream var4 = null;

      label70: {
         try {
            try {
               String var5 = EC5Util.char("\u001628");
               HashMap var6;
               (var6 = new HashMap()).put(EncodeHintType.CHARACTER_SET, "UTF-8");
               BitMatrix a4 = (new MultiFormatWriter()).encode(a, BarcodeFormat.QR_CODE, a1, a2, var6);
               File a5 = new File(a3);
               var4 = new FileOutputStream(a5);
               MatrixToImageWriter.writeToStream(a4, var5, var4);
               break label70;
            } catch (Exception var16) {
               C.error(EC5Util.char("畀扒仓纶硝冻镊ｏ\u000b22\u0019#\u0018+69ｒ\u0000\f<%)%\u00134119-0\u000ejv"), var16);
            }
         } catch (Throwable var17) {
            Throwable var10000;
            try {
               var4.close();
            } catch (IOException var15) {
               C.error(EC5Util.char("畀扒仓纶硝冻镊ｏ\u000b22\u0019#\u0018+69ｒ\u0000\f<%)%\u00134119-0\u000ejv"), var15);
               var10000 = var17;
               throw var10000;
            }

            var10000 = var17;
            throw var10000;
         }

         try {
            var4.close();
            return;
         } catch (IOException var13) {
            C.error(ClassKit.throw("畛扰仄纘硔冋镛ｧ@@1#\'%fB\u0002ｐ)\u001c%\u0005\u00027\u0006\u0018\u001e\'$\t\u0019\u001ecF"), var13);
            return;
         }
      }

      try {
         var4.close();
      } catch (IOException var14) {
         C.error(ClassKit.throw("畛扰仄纘硔冋镛ｧ@@1#\'%fB\u0002ｐ)\u001c%\u0005\u00027\u0006\u0018\u001e\'$\t\u0019\u001ecF"), var14);
      }
   }

   public static void main(String[] a) throws IOException {
      int var1;
      for(int var10000 = var1 = 1; var10000 <= 1; var10000 = var1) {
         QrImage.Builder var2 = (new QrImage.Builder()).setFileOutputPath((new StringBuilder()).insert(0, EC5Util.char("\u001bx\u0000仍纩硁\r8<7*\u001f")).append(var1).append(ClassKit.throw("f\u0006;\b")).toString()).setQrContent(EC5Util.char("\u0011\u0010)0meN\u000b5(J\u001b>+;7r\"2-n-dulp")).setQrHeight(300).setQrWidth(300).setQrIconFilePath(ClassKit.throw("\u000ep2仌纐硷\u000e乸閅嚍桐\u0014]f\u001c%\b")).setTopWrodHeight(100).setWordContent(EC5Util.char("8<7*r"));
         ++var1;
         createQrWithFontsAbove(var2.setWordSize(18).build());
      }

   }

   public static void createQrWithFontsAbove(QrImage a) {
      try {
         BufferedImage var1;
         BufferedImage var10001 = var1 = native(a.getQrContent(), a.getQrWidth(), a.getQrHeight(), a.getQrIconFilePath());
         int var2 = var10001.getWidth();
         int var3 = var10001.getHeight();
         String[] var4 = null;
         int var5 = (var4 = char(a.getWordContent(), var2 / a.getWordSize())).length * a.getWordSize() + 10;
         BufferedImage var6;
         Graphics var7 = (var6 = new BufferedImage(var2, var5, 6)).getGraphics();
         var7.fillRect(0, 0, var2, var5);
         var7.setColor(Color.black);
         Font var10002 = new Font;
         var7.<init>(EC5Util.char("寞伛"), 0, a.getWordSize());
         var10002.setFont(var7);
         int var8;
         if(var7.getWordContent().length() > var2 / a.getWordSize()) {
            for(int var14 = var8 = 0; var14 < var4.length; var14 = var8) {
               var7.drawString(var4[var8], 0, a.getWordSize() * (var8++ + 1));
            }
         } else {
            var7.drawString(a.getWordContent(), (var2 / a.getWordSize() - a.getWordContent().length()) / 2 * a.getWordSize() + 20, a.getWordSize());
         }

         int[] var15 = new int[var2 * var5];
         Object var12 = true;
         int[] var13 = var6.getRGB(0, 0, var2, var5, (int[])var12, 0, var2);
         int[] var17 = new int[var2 * var3];
         var4 = true;
         int[] var11 = var1.getRGB(0, 0, var2, var3, (int[])var4, 0, var2);
         var6 = new BufferedImage(var2, var3 + var5, 1);
         var6.setRGB(0, 0, var2, var5, var13, 0, var2);
         var6.setRGB(0, var5, var2, var3, var11, 0, var2);
         File var10 = new File(a.getFileOutputPath());
         ImageIO.write(var6, ClassKit.throw("\u0006;\b"), var10);
      } catch (Exception var9) {
         var9.printStackTrace();
      }
   }

   public static void encode(String a, int a1, int a2, String a3, String a4) {
      try {
         ImageIO.write(native(a, a1, a2, a3), EC5Util.char("#%/"), new File(a4));
      } catch (IOException var5) {
         var5.printStackTrace();
      } catch (WriterException var6) {
         var6.printStackTrace();
      }
   }

   // $FF: synthetic method
   private static String[] char(String a, int a1) {
      int var2;
      String[] var10000 = new String[var2 = a.length() / a1 + 1];
      Object var3 = true;

      int var4;
      for(int var10001 = var4 = 0; var10001 < var2; var10001 = var4) {
         if((var4 + 1) * a1 > a.length()) {
            ((Object[])var3)[var4] = a.substring(var4 * a1);
         } else {
            ((Object[])var3)[var4] = a.substring(var4 * a1, (var4 + 1) * a1);
         }

         ++var4;
      }

      return (String[])var3;
   }

   // $FF: synthetic method
   private static BufferedImage native(String a, int a1, int a2, String a3) throws WriterException, IOException {
      BufferedImage var10 = interface(a3, 80, 80, true);
      int[][] var4 = new int[80][80];

      int var5;
      int var10002;
      for(int var10000 = var5 = 0; var10000 < var10.getWidth(); var10000 = var5) {
         int var6;
         for(var10000 = var6 = 0; var10000 < var10.getHeight(); var10000 = var6) {
            int[] var14 = var4[var5];
            int var10001 = var6;
            var10002 = var10.getRGB(var5, var6);
            ++var6;
            var14[var10001] = var10002;
         }

         ++var5;
      }

      HashMap var12;
      (var12 = new HashMap()).put(EncodeHintType.CHARACTER_SET, ClassKit.throw("\u0019<\nfW"));
      var12.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
      var12.put(EncodeHintType.MARGIN, Integer.valueOf(1));
      BitMatrix var13;
      BitMatrix var10003 = var13 = F.encode(a, BarcodeFormat.QR_CODE, a1, a2, var12);
      int var11 = var10003.getWidth() / 2;
      var5 = var10003.getHeight() / 2;
      int[] var15 = new int[a1 * a2];
      Object var7 = true;
      int var8 = 0;

      for(var10002 = var8; var10002 < var13.getHeight(); var10002 = var8) {
         int var9;
         for(var10002 = var9 = 0; var10002 < var13.getWidth(); var10002 = var9) {
            if(var9 > var11 - 40 && var9 < var11 + 40 && var8 > var5 - 40 && var8 < var5 + 40) {
               ((Object[])var7)[var8 * a1 + var9] = var4[var9 - var11 + 40][var8 - var5 + 40];
            } else if((var9 <= var11 - 40 - 2 || var9 >= var11 - 40 + 2 || var8 <= var5 - 40 - 2 || var8 >= var5 + 40 + 2) && (var9 <= var11 + 40 - 2 || var9 >= var11 + 40 + 2 || var8 <= var5 - 40 - 2 || var8 >= var5 + 40 + 2) && (var9 <= var11 - 40 - 2 || var9 >= var11 + 40 + 2 || var8 <= var5 - 40 - 2 || var8 >= var5 - 40 + 2) && (var9 <= var11 - 40 - 2 || var9 >= var11 + 40 + 2 || var8 <= var5 + 40 - 2 || var8 >= var5 + 40 + 2)) {
               ((Object[])var7)[var8 * a1 + var9] = var13.get(var9, var8)?-16777216:268435455;
            } else {
               ((Object[])var7)[var8 * a1 + var9] = 268435455;
            }

            ++var9;
         }

         ++var8;
      }

      BufferedImage var16 = new BufferedImage(a1, a2, 1);
      var16.getRaster().setDataElements(0, 0, a1, a2, var7);
      return var16;
   }

   // $FF: synthetic method
   private static BufferedImage interface(String a, int a1, int a2, boolean a3) throws IOException {
      double var4 = 0.0D;
      BufferedImage var6;
      BufferedImage var10000 = var6 = ImageIO.read(new File(a));
      Object var7 = var10000.getScaledInstance(a2, a1, 4);
      if(var10000.getHeight() > a1 || var6.getWidth() > a2) {
         if(var6.getHeight() > var6.getWidth()) {
            var4 = (new Integer(a1)).doubleValue() / (double)var6.getHeight();
         } else {
            var4 = (new Integer(a2)).doubleValue() / (double)var6.getWidth();
         }

         var7 = (new AffineTransformOp(AffineTransform.getScaleInstance(var4, var4), (RenderingHints)null)).filter(var6, (BufferedImage)null);
      }

      if(a3) {
         BufferedImage var8;
         Graphics2D a4 = (var8 = new BufferedImage(a2, a1, 1)).createGraphics();
         a4.setColor(Color.white);
         a4.fillRect(0, 0, a2, a1);
         Graphics2D var10;
         if(a2 == ((Image)var7).getWidth((ImageObserver)null)) {
            var10 = a4;
            a4.drawImage((Image)var7, 0, (a1 - ((Image)var7).getHeight((ImageObserver)null)) / 2, ((Image)var7).getWidth((ImageObserver)null), ((Image)var7).getHeight((ImageObserver)null), Color.white, (ImageObserver)null);
         } else {
            var10 = a4;
            a4.drawImage((Image)var7, (a2 - ((Image)var7).getWidth((ImageObserver)null)) / 2, 0, ((Image)var7).getWidth((ImageObserver)null), ((Image)var7).getHeight((ImageObserver)null), Color.white, (ImageObserver)null);
         }

         var10.dispose();
         var7 = var8;
      }

      return (BufferedImage)var7;
   }
}
